[![Specs](https://github.com/matestack/matestack-ui-bootstrap/workflows/specs/badge.svg)](https://github.com/matestack/matestack-ui-bootstrap/actions)
[![Discord](https://img.shields.io/discord/771413294136426496.svg)](https://discord.com/invite/c6tQxFG)
[![Gem Version](https://badge.fury.io/rb/matestack-ui-bootstrap.svg)](https://badge.fury.io/rb/matestack-ui-bootstrap)
[![Docs](https://img.shields.io/badge/docs-matestack-blue.svg)](https://docs.matestack.io/matestack-ui-bootstrap)
[![Twitter Follow](https://img.shields.io/twitter/follow/matestack.svg?style=social)](https://twitter.com/matestack)

![matestack logo](./logo.png)

# matestack-ui-bootstrap | beautiful, reactive UIs in pure Ruby

As an extension for [`matestack-ui-core`](https://github.com/matestack/matestack-ui-core), `matestack-ui-bootstrap` ships all you need to build beautiful,
reactive UIs in pure Ruby and smart CRUD components based on Bootstrap v5.

----

`matestack-ui-core` enables you to craft maintainable web UIs in pure Ruby, skipping ERB and HTML. UI code becomes a native and fun part of your Rails app. Thanks to reactive core components, reactivity can be optionally added on top without writing JavaScript, just using a simple Ruby DSL.

You end up writing 50% less code while increasing productivity, maintainability and developer happiness. Work with pure Ruby. If necessary, extend with pure JavaScript. No Opal involved.

----

`matestack-ui-core` does not have an opinion on styling. In contrast, `matestack-ui-bootstrap` ships all Bootstrap v5 components as Matestack UI components usable in pure Ruby. Additionally layout and CRUD components help you to build a beautiful web app meeting typical requirements of a data driven web app.

Don't think about styling anymore and just create admin or application UIs faster than ever before!

[<img src="https://img.youtube.com/vi/bwsVgCb97v0/0.jpg" width="350">](https://www.youtube.com/watch?v=bwsVgCb97v0)

## Compatibility

### Ruby/Rails

`matestack-ui-bootstrap` is tested against:

- Rails 6.1.1 + Ruby 3.0.0
- Rails 6.1.1 + Ruby 2.7.2
- Rails 6.0.3.4 + Ruby 2.6.6
- Rails 5.2.4.4 + Ruby 2.6.6

Rails versions below 5.2 are not supported.

### Vue.js

`matestack-ui-bootstrap` requires Vue.js and Vuex for its reactivity features. Following version ranges are supported:

- Vue.js ^2.6.0
- Vuex ^3.6.0

Vue 3 / Vuex 4 update is planned for Q2 2021.

## Documentation/Installation

Documentation can be found [here](https://docs.matestack.io/matestack-ui-bootstrap)

## Changelog

Changelog can be found [here](./CHANGELOG.md)

## License

`matestack-ui-bootstrap` is an Open Source project licensed under the terms of the [MIT license](./LICENSE)
